#include <gtk/gtk.h>

void 
on_button_clicked (GtkButton *button, gpointer data)
{
	GObject     *window;
	GtkLabel    *label;
	GtkEntry    *entry;
	const gchar *text;
	
	window = G_OBJECT (data);
	
	label = GTK_LABEL (g_object_get_data (window, "label"));
	entry = GTK_ENTRY (g_object_get_data (window, "text_entry"));

	text = gtk_entry_get_text (entry);
	
	gtk_label_set_text (label, text);
}

GtkWidget *
construct_window (void)
{
	GtkWidget *window;
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *label;
	GtkWidget *button;
	GtkWidget *text_entry;

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "ejemplo");
	/* 10 px. de borde en la ventana */
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_container_add (GTK_CONTAINER (window), vbox);

	/* 10 px. de espacio entre la caja de texto y el bot'on que crearemos
	   m'as adelante. */
	hbox = gtk_hbox_new (FALSE, 10);
	
	/* 10 px. de espacio entre la caja horizontal y su alrededor */
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 10);

	text_entry = gtk_entry_new ();
	/* Queremos que la caja de texto se expanda horizontalmente y llene
	   todo el espacio que tiene asignado */
	gtk_box_pack_start (GTK_BOX (hbox), text_entry, TRUE, TRUE, 0);

	button = gtk_button_new_from_stock (GTK_STOCK_APPLY);
	/* No queremos expandir el bot'on, ya que su tamaño por defecto
	   est'a bonito */
	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
	
	label = gtk_label_new ("ejemplo");
	/* los mismos 10 px. de espacio entre la etiqueta y su alrededor */
	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);

	g_object_set_data (G_OBJECT (window), "label", label);
	g_object_set_data (G_OBJECT (window), "text_entry", text_entry);

	g_signal_connect (G_OBJECT (button), "clicked", 
			  G_CALLBACK (on_button_clicked), window);
	
	return window;
}

int
main (gint argc, gchar **argv)
{
	gtk_init (&argc, &argv);
	GtkWidget *window = construct_window ();

	gtk_widget_show_all (window);
	g_signal_connect (G_OBJECT (window), "delete-event", 
			  gtk_main_quit, NULL);

	gtk_main ();

	return 0;
}
